Subject: Re: [ppsp] PPSP Protocols

From: "Victor Pascual Ávila" <[email-masked]>
Date: Mon, 5 Jan 2009 13:52:51 +0100

On Tue, Dec 2, 2008 at 2:10 PM, James Seng <[email-masked]> wrote:
> The (peer discovery) situation may looks similar but they are actually
> quite different.
>
> In P2PSIP, the purpose is to identify the unique other end-point for
> the communication.
>
> In P2P Streaming, the discovery is not to find the other unique
> end-point but a set of peers.

"The other unique end-point" might be a list of peers. Discover them
using the overlay and set-up direct connections to exchange buffer
maps.

Cheers,
-Victor

>
> Apple & Orange. Both are fruits but obviously quite different.
>
> -James Seng
>
> On Tue, Dec 2, 2008 at 3:51 PM, Xiao, Lin (NSN - CN/Beijing)
> <[email-masked]> wrote:
>> Hi Hui,
>>
>> Yes, you are right, "1 to 1" and "1 to m" is the major difference.
>>
>> However, we can put the info of all the corresponding peers in a peer list, right?  So, the process to find the multiple peers could be replaced by discovering this peer list. And peer lists related to certain content can be looked as resources stored in the overlay which are equivalent to the peer registration infor in P2PSIP. Then, it is actually the problem to locate the right tracker with the right peer list in the overlay.  So that, there is no much difference between P2PSIP and PPSP in step (1) if we look trackers as peers in the overlay.
>>
>> But, obviously, the Peer Gossiping communication is not within the description of step (1), which seems also a part of PPSP signalling protocol.
>>
>>
>>
>> Best Regards,
>> Xiao Lin
>>
>>
>>
>>
>> -----Original Message-----
>> From: ext Hui Zhang [mailto:[email-masked]]
>> Sent: Tuesday, December 02, 2008 3:12 PM
>> To: Xiao, Lin (NSN - CN/Beijing); ext Song Haibin; Das, Saumitra; yunfei zhang
>> Cc: [email-masked]
>> Subject: RE: [ppsp] PPSP Protocols
>>
>> Hi Xiao Lin,
>>
>> Interesting comparison & analysis. One point I would like to add is that in (1), for P2PSIP it's 1:1 static relationship for sender/receiver, while for PPSP it's N:M dynamic relationship, which is the core part PPSP signaling protocol tries to tackle.
>>
>> Regards,
>>
>> Hui
>>
>> -----Original Message-----
>> From: [email-masked] [mailto:[email-masked]] On Behalf Of Xiao, Lin (NSN - CN/Beijing)
>> Sent: Tuesday, December 02, 2008 12:31 AM
>> To: ext Song Haibin; Das, Saumitra; yunfei zhang
>> Cc: [email-masked]
>> Subject: Re: [ppsp] PPSP Protocols
>>
>> Interesting discussion.
>>
>> In order to make things clear, I'd like to draw a picture of the relationship between P2PSIP and PPSP and analyze their similar and difference.
>>
>> Logically, there are two main steps in both P2PSIP and P2PP: (1) searching for the other side node(s) of the communication and (2) setting up traffic connection(s) and transmission(s). The step (2) basically depends on the transport protocol (TCP/UDP, RTP...) and IP. The step (1) is solved by the DHT overly in P2PSIP because of the distribution of the registration info; while it is solved by tracker(s) in PPSP.
>>
>> During the whole process of a traffic session, send(s) and receiver(s) could be logically looked as nodes outside the P2P overlay (or called the clients of the overlay/trackers), although they can coexist with the overlay peers/trackers in the same entities. Therefore, the whole logical topology could be described logically by only sender(s)/receiver and a overlay (or tracker (s)) :
>>
>> For P2PSIP:
>> Sender/receiver <--  (1) -->  (P2P overlay organized by DHT ) <-- (1) --> receiver/sender
>>       |                                                                                                             |
>>       |______________|-->                               (2)                       <--|__________|
>>
>>
>>
>>
>> For PPSP:
>> receiver <--  (1) -->    ( Tracker(s) which could be organized by DHT)          <--  (1) --> sender
>>    |                                                                                                               |  --> sender
>>    |                                                                                                               :
>>    |                                                                                                               |  --> senders
>>    |                                                                                                                            |
>>    |______________|-->                             (2)                                    -->|____________|
>>
>>
>>
>>
>> And the corresponding relationship between logical entities of P2PSIP and PPSP could be list as following:
>>
>>   P2PSIP                                                             PPSP
>> DHT overlay                                =                     Tracker(s)
>> Sender/receiver                           =                    senders/receiver
>> Registration Info of certain peer     =              peer lists related to certain resources
>> Encoded voice packets                =                   streaming chunks
>>
>>
>>
>> To my understanding the P2PSIP mainly try to solve the searching problems in step (1) and PPSP focuses on the point to multi-points transmission issues in step (2). And the DHT is used to organize the peers and resources, and to give a routing method for quick searching within highly distributed registration info or trackers.
>>
>> It seems that, we can also look track(s) as a peer (or peers), and then the tracker(s) searching can be based on DHT, which is in the same scope of P2PSIP. If only one track is used, URI maybe a more direct way. This, I thank, need further discussion. However, the behavior of step (2) is something need to be considered more which is out of the scope of P2PSIP. However, the possibility that to extend the current RTP/RTSP to support step (2) worth further consideration.
>>
>>
>> Best Regards,
>> Xiao Lin
>>
>>
>>
>>
>>
>> -----Original Message-----
>> From: [email-masked] [mailto:[email-masked]] On Behalf Of ext Song Haibin
>> Sent: Tuesday, December 02, 2008 10:36 AM
>> To: 'Das, Saumitra'; 'yunfei zhang'
>> Cc: [email-masked]
>> Subject: Re: [ppsp] PPSP Protocols
>>
>>>-----Original Message-----
>>>From: Das, Saumitra [mailto:[email-masked]]
>>>Sent: Tuesday, December 02, 2008 9:05 AM
>>
>>>I meant the DHT can be used to search for a tracker for a content item.
>> Beyond
>>>that drag and drop operations for searching for streaming segments can
>>>be
>> made
>>>directly with the tracker node or with a random set of nodes that the
>> tracker
>>>provides interested in the stream. These communications need not always
>>>use
>> the
>>>DHT routing but still can benefit by initially communicating via
>>>nodeids
>> reusing
>>>the overlay and nat/firewall tranversal modules. Once a direct
>>>connection
>> is
>>>established with peers bitmap exchange can take place.
>>
>> I think it is somewhat similar to OpenDHT. It has no obvious differences with the normal tracker based p2p system, except that the first step is a DHT search for a tracker for a particular content.
>>
>> I also agree with you on the nat/fw traversal problem. I think designing PPSP protocol should consider this problem.
>>
>> IMHO bitmap exchange can be a standardized point here.
>>
>> My two cents,
>> Song Haibin
>>
>>>Best,
>>>Saumitra
>>>
>>>-----Original Message-----
>>>From: Song Haibin [mailto:[email-masked]]
>>>Sent: Monday, December 01, 2008 4:52 PM
>>>To: Das, Saumitra; 'yunfei zhang'
>>>Cc: [email-masked]
>>>Subject: RE: [ppsp] PPSP Protocols
>>>
>>>>-----Original Message-----
>>>>From: [email-masked] [mailto:[email-masked]] On Behalf
>>>>Of
>>>Das,
>>>>Saumitra
>>>
>>>>Hi Yunfei,
>>>>
>>>>As long as the tracker refers to nodes with nodeids any node in the
>> overlay
>>>can
>>>>use it to communicate. The overlay could be a more general overlay of
>> nodes
>>>>interested in pspp as well similar to some torrent implementations in
>> which
>>>a
>>>>DHT is built overall and not per content item.
>>>
>>>A DHT built for all is good. But I am not sure if DHT can satisfy every
>>>application, e.g. VOD applications, since there are many click-and-drag
>>>operations, if the DHT discovery efficient for searching streaming
>>>segments is unknown. But if you have distributed trackers architecture
>>>in mind, I think it will make sense to implement DHT among trackers.
>>>
>>>Best Regards!
>>>Song Haibin
>>>
>>>
>>>>Thanks
>>>>Saumitra
>>>>
>>>>
>>>>
>>>>From: yunfei zhang [mailto:[email-masked]]
>>>>Sent: Monday, December 01, 2008 1:36 AM
>>>>To: Das, Saumitra
>>>>Cc: Victor Pascual Ávila; [email-masked]
>>>>Subject: Re: [ppsp] PPSP Protocols
>>>>
>>>>Hi,Das,Thanks for your comments.
>>>>1)It's unsuitable viewing PPSP a overlaid usage on top of RELOAD.But
>>>>as
>>>mentioned
>>>>in the bar bof, the work of distributing trackers can use P2PSIP as
>>>>the
>>>supporting
>>>>protocol.
>>>>As for exchanging bitmap,it's a task of using direct connection
>>>>between
>> two
>>>>NOT-KNOWN-BEFORE nodes,so there are no nodeid->nodeid connections that
>>>>can
>>>be
>>>>built in PPSP envrinment.
>>>>2)I agree with you in this point.In fact we should discuss the
>>>>possibilty
>>>of
>>>>reusing current IETF protocols in both signaling and transmission
>> protocols
>>>>since we need to limit the scope of PPSP.
>>>>I agree with you that the main question the BOF brought up is what
>>>>exactly
>>>is
>>>>being standardized here (which components of the overall problem) and
>>>why.I'd
>>>>like to launch a discussion in PPSP mailing list shortly.
>>>>
>>>>                           Yunfei
>>>>
>>>>
>>>>
>>>>2008/12/1, Das, Saumitra <[email-masked]>:
>>>>I think these are some of the things that need to be discussed based
>>>>on
>> the
>>>Minn
>>>>BOF.
>>>>
>>>>1. Can PPSP signaling be overlaid as a usage on top of RELOAD. I think
>> this
>>>can
>>>>be a separate usage for reload on the same level as SIP. One obvious
>>>>use
>> is
>>>to
>>>>implement a distributed tracker. Now whether reload should be used for
>>>>exchanging bitmaps etc (if that is what we determine the main thing
>>>>the
>>>signaling
>>>>does) by making direct nodeid->nodeid connections; should be discussed.
>>>>
>>>>2. I agree we need to define what are the goals of the PPSP
>>>>transmission
>>>protocol.
>>>>Since this is on demand/live streaming ledbat does not apply. Can we
>>>>reuse
>>>some
>>>>existing transport?
>>>>
>>>>But before these questions, I think the main question the BOF brought
>>>>up
>> is
>>>what
>>>>exactly is being standardized here (which components of the overall
>>>problem)
>>>>and why.
>>>>
>>>>Thanks,
>>>>Saumitra
>>>>
>>>>-----Original Message-----
>>>>From: [email-masked] [mailto:[email-masked]] On Behalf
>>>>Of
>>>Victor
>>>>Pascual Ávila
>>>>Sent: Wednesday, November 26, 2008 3:08 AM
>>>>To: [email-masked]
>>>>Subject: [ppsp] PPSP Protocols
>>>>
>>>>Hi,
>>>>(trying to catch up with the discussion)
>>>>
>>>>PPSP Signaling Protocol:
>>>>
>>>>On Thu, 23 Oct 2008 11:02:44 +0800, Song Haibin posted a message[1]
>>>>that does not seem to have generated much echo (browsing the
>>>>discussion archive I failed to find any response).
>>>>
>>>>[1] http://www.ietf.org/mail-archive/web/ppsp/current/msg00005.html
>>>>
>>>>Is there any significant difference between "PPSP Signaling Procotol"
>>>>and "P2PSIP Peer Protocol + SIP + OTSp2p-like algorithm"?
>>>>
>>>>PPSP Transmission Protocol:
>>>>
>>>>Why isn't RTP sufficient for this?
>>>>
>>>>Cheers and excuse me if it has been already discussed,
>>>>--
>>>>Victor Pascual Ávila
>>>>_______________________________________________
>>>>ppsp mailing list
>>>>[email-masked]
>>>>https://www.ietf.org/mailman/listinfo/ppsp
>>>>_______________________________________________
>>>>ppsp mailing list
>>>>[email-masked]
>>>>https://www.ietf.org/mailman/listinfo/ppsp
>>>>
>>>>_______________________________________________
>>>>ppsp mailing list
>>>>[email-masked]
>>>>https://www.ietf.org/mailman/listinfo/ppsp
>>
>> _______________________________________________
>> ppsp mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/ppsp
>> _______________________________________________
>> ppsp mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/ppsp
>> _______________________________________________
>> ppsp mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/ppsp
>>
> _______________________________________________
> ppsp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ppsp
>

-- 
Victor Pascual Ávila
_______________________________________________
ppsp mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/ppsp